package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static int _screenwidth = 0;
public static int _screenheight = 0;
public static int _view_width = 0;
public static int _view_height = 0;
public anywheresoftware.b4a.libgdx.LibGDX _lgdx = null;
public anywheresoftware.b4a.libgdx.graphics.lgGL _gl = null;
public anywheresoftware.b4a.libgdx.input.lgInputProcessor _inp = null;
public anywheresoftware.b4a.libgdx.graphics.lgOrthographicCamera _camera = null;
public com.badlogic.gdx.maps.tiled.TiledMap _mapani = null;
public anywheresoftware.b4a.libgdx.maps.lgOrthogonalTiledMapRenderer _rndani = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
com.badlogic.gdx.backends.android.AndroidApplicationConfiguration _config = null;
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 38;BA.debugLine="Dim Config As lgConfiguration";
_config = new com.badlogic.gdx.backends.android.AndroidApplicationConfiguration();
 //BA.debugLineNum = 41;BA.debugLine="Config.useAccelerometer = False";
_config.useAccelerometer = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 42;BA.debugLine="Config.useCompass = False";
_config.useCompass = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 43;BA.debugLine="Config.useWakelock = True";
_config.useWakelock = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 46;BA.debugLine="Config.maxSimultaneousSounds = 4";
_config.maxSimultaneousSounds = (int) (4);
 //BA.debugLineNum = 51;BA.debugLine="lGdx.Initialize2(Config, \"LG\")";
mostCurrent._lgdx.Initialize2(mostCurrent.activityBA,_config,"LG");
 //BA.debugLineNum = 52;BA.debugLine="lGdx.Input.CatchBackKey = False";
mostCurrent._lgdx.Input().setCatchBackKey(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 54;BA.debugLine="Inp.Initialize(\"Inp\")";
mostCurrent._inp.Initialize(processBA,"Inp");
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 61;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 62;BA.debugLine="If lGdx.IsInitialized Then lGdx.Pause";
if (mostCurrent._lgdx.IsInitialized()) { 
mostCurrent._lgdx.Pause();};
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 58;BA.debugLine="If lGdx.IsInitialized Then lGdx.Resume";
if (mostCurrent._lgdx.IsInitialized()) { 
mostCurrent._lgdx.Resume();};
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Dim lGdx As LibGDX";
mostCurrent._lgdx = new anywheresoftware.b4a.libgdx.LibGDX();
 //BA.debugLineNum = 27;BA.debugLine="Dim GL As lgGL";
mostCurrent._gl = new anywheresoftware.b4a.libgdx.graphics.lgGL();
 //BA.debugLineNum = 28;BA.debugLine="Dim Inp As lgInputProcessor";
mostCurrent._inp = new anywheresoftware.b4a.libgdx.input.lgInputProcessor();
 //BA.debugLineNum = 30;BA.debugLine="Dim Camera As lgOrthographicCamera";
mostCurrent._camera = new anywheresoftware.b4a.libgdx.graphics.lgOrthographicCamera();
 //BA.debugLineNum = 31;BA.debugLine="Dim mapAni As lgMapTiledMap";
mostCurrent._mapani = new com.badlogic.gdx.maps.tiled.TiledMap();
 //BA.debugLineNum = 32;BA.debugLine="Dim rndAni As lgMapOrthogonalTiledMapRenderer";
mostCurrent._rndani = new anywheresoftware.b4a.libgdx.maps.lgOrthogonalTiledMapRenderer();
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static boolean  _inp_touchdown(int _screenx,int _screeny,int _pointer) throws Exception{
int _viewx = 0;
int _viewy = 0;
int _tilex = 0;
int _tiley = 0;
 //BA.debugLineNum = 134;BA.debugLine="Sub Inp_TouchDown(ScreenX As Int, ScreenY As Int, Pointer As Int) As Boolean";
 //BA.debugLineNum = 135;BA.debugLine="Dim ViewX,ViewY As Int";
_viewx = 0;
_viewy = 0;
 //BA.debugLineNum = 137;BA.debugLine="ViewX = ScreenX / ScreenWidth * VIEW_WIDTH";
_viewx = (int) (_screenx/(double)_screenwidth*_view_width);
 //BA.debugLineNum = 138;BA.debugLine="ViewY = VIEW_HEIGHT - (ScreenY / ScreenHeight * VIEW_HEIGHT)";
_viewy = (int) (_view_height-(_screeny/(double)_screenheight*_view_height));
 //BA.debugLineNum = 140;BA.debugLine="Dim TileX,TileY As Int";
_tilex = 0;
_tiley = 0;
 //BA.debugLineNum = 142;BA.debugLine="TileX = (ViewX - 512) / 32";
_tilex = (int) ((_viewx-512)/(double)32);
 //BA.debugLineNum = 143;BA.debugLine="TileY = (ViewY - 320) / 32";
_tiley = (int) ((_viewy-320)/(double)32);
 //BA.debugLineNum = 145;BA.debugLine="Log(\"Tile Position: \" & TileX & \", \" & TileY)";
anywheresoftware.b4a.keywords.Common.Log("Tile Position: "+BA.NumberToString(_tilex)+", "+BA.NumberToString(_tiley));
 //BA.debugLineNum = 146;BA.debugLine="End Sub";
return false;
}
public static String  _lg_create() throws Exception{
anywheresoftware.b4a.libgdx.maps.lgTmxMapLoader _loader = null;
 //BA.debugLineNum = 65;BA.debugLine="Sub LG_Create";
 //BA.debugLineNum = 66;BA.debugLine="Dim loader As lgMapTmxMapLoader";
_loader = new anywheresoftware.b4a.libgdx.maps.lgTmxMapLoader();
 //BA.debugLineNum = 68;BA.debugLine="mapAni = loader.Initialize2(\"maps/tilemap.tmx\")";
mostCurrent._mapani = _loader.Initialize2("maps/tilemap.tmx");
 //BA.debugLineNum = 69;BA.debugLine="rndAni.Initialize(mapAni)";
mostCurrent._rndani.Initialize(mostCurrent._mapani);
 //BA.debugLineNum = 71;BA.debugLine="SetAnimatedTile";
_setanimatedtile();
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _lg_dispose() throws Exception{
 //BA.debugLineNum = 129;BA.debugLine="Sub LG_Dispose";
 //BA.debugLineNum = 130;BA.debugLine="rndAni.dispose";
mostCurrent._rndani.dispose();
 //BA.debugLineNum = 131;BA.debugLine="mapAni.dispose";
mostCurrent._mapani.dispose();
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}
public static String  _lg_render() throws Exception{
 //BA.debugLineNum = 117;BA.debugLine="Sub LG_Render";
 //BA.debugLineNum = 119;BA.debugLine="GL.glClearColor(0, 0, 0, 1)";
mostCurrent._gl.glClearColor((float) (0),(float) (0),(float) (0),(float) (1));
 //BA.debugLineNum = 120;BA.debugLine="GL.glClear(GL.GL10_COLOR_BUFFER_BIT)";
mostCurrent._gl.glClear(mostCurrent._gl.GL10_COLOR_BUFFER_BIT);
 //BA.debugLineNum = 123;BA.debugLine="rndAni.render()";
mostCurrent._rndani.Render();
 //BA.debugLineNum = 124;BA.debugLine="End Sub";
return "";
}
public static String  _lg_resize(int _width,int _height) throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub LG_Resize(Width As Int, Height As Int)";
 //BA.debugLineNum = 98;BA.debugLine="ScreenWidth = Width";
_screenwidth = _width;
 //BA.debugLineNum = 99;BA.debugLine="ScreenHeight = Height";
_screenheight = _height;
 //BA.debugLineNum = 100;BA.debugLine="VIEW_HEIGHT = VIEW_WIDTH * Height / Width";
_view_height = (int) (_view_width*_height/(double)_width);
 //BA.debugLineNum = 102;BA.debugLine="Camera.Initialize";
mostCurrent._camera.Initialize();
 //BA.debugLineNum = 106;BA.debugLine="Camera.ViewportWidth = VIEW_WIDTH";
mostCurrent._camera.setViewportWidth((float) (_view_width));
 //BA.debugLineNum = 108;BA.debugLine="Camera.ViewportHeight = VIEW_HEIGHT";
mostCurrent._camera.setViewportHeight((float) (_view_height));
 //BA.debugLineNum = 110;BA.debugLine="Camera.Zoom = 1";
mostCurrent._camera.setZoom((float) (1));
 //BA.debugLineNum = 112;BA.debugLine="Camera.Position.Set(0,96,0)";
mostCurrent._camera.getPosition().set((float) (0),(float) (96),(float) (0));
 //BA.debugLineNum = 113;BA.debugLine="Camera.Update";
mostCurrent._camera.Update();
 //BA.debugLineNum = 114;BA.debugLine="rndAni.SetCameraView(Camera)";
mostCurrent._rndani.SetCameraView(mostCurrent._camera);
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _lg_update() throws Exception{
 //BA.debugLineNum = 126;BA.debugLine="Sub LG_Update";
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim ScreenWidth As Int = 0";
_screenwidth = (int) (0);
 //BA.debugLineNum = 17;BA.debugLine="Dim ScreenHeight As Int = 0";
_screenheight = (int) (0);
 //BA.debugLineNum = 19;BA.debugLine="Dim VIEW_WIDTH As Int = 1024";
_view_width = (int) (1024);
 //BA.debugLineNum = 20;BA.debugLine="Dim VIEW_HEIGHT As Int ' Set in screen initialisation as it's device dependent";
_view_height = 0;
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _setanimatedtile() throws Exception{
com.badlogic.gdx.maps.tiled.tiles.AnimatedTiledMapTile _anitile = null;
com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile[] _frames = null;
com.badlogic.gdx.maps.tiled.TiledMapTileLayer _layer = null;
com.badlogic.gdx.maps.tiled.TiledMapTileLayer.Cell _cell = null;
anywheresoftware.b4a.objects.collections.List _x = null;
Object _key = null;
 //BA.debugLineNum = 74;BA.debugLine="Sub SetAnimatedTile";
 //BA.debugLineNum = 75;BA.debugLine="Dim AniTile As lgMapAnimatedTiledMapTile";
_anitile = new com.badlogic.gdx.maps.tiled.tiles.AnimatedTiledMapTile();
 //BA.debugLineNum = 76;BA.debugLine="Dim Frames(3) As lgMapStaticTiledMapTile";
_frames = new com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile[(int) (3)];
{
int d0 = _frames.length;
for (int i0 = 0;i0 < d0;i0++) {
_frames[i0] = new com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile();
}
}
;
 //BA.debugLineNum = 78;BA.debugLine="Frames(0) = mapAni.TileSets.getTileSet(0).getTile(3)";
_frames[(int) (0)] = (com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile)(mostCurrent._mapani.getTileSets().getTileSet((int) (0)).getTile((int) (3)));
 //BA.debugLineNum = 79;BA.debugLine="Frames(1) = mapAni.TileSets.getTileSet(0).getTile(2)";
_frames[(int) (1)] = (com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile)(mostCurrent._mapani.getTileSets().getTileSet((int) (0)).getTile((int) (2)));
 //BA.debugLineNum = 80;BA.debugLine="Frames(2) = mapAni.TileSets.getTileSet(0).getTile(1)";
_frames[(int) (2)] = (com.badlogic.gdx.maps.tiled.tiles.StaticTiledMapTile)(mostCurrent._mapani.getTileSets().getTileSet((int) (0)).getTile((int) (1)));
 //BA.debugLineNum = 82;BA.debugLine="AniTile.Initialize(100,Frames)";
_anitile.Initialize((float) (100),_frames);
 //BA.debugLineNum = 84;BA.debugLine="Dim layer As lgMapTiledMapLayer = mapAni.Layers.Get(0)";
_layer = (com.badlogic.gdx.maps.tiled.TiledMapTileLayer)(mostCurrent._mapani.getLayers().Get((int) (0)));
 //BA.debugLineNum = 85;BA.debugLine="Dim cell As lgMapTiledMapLayerCell = layer.getCell(0,0)";
_cell = _layer.getCell((int) (0),(int) (0));
 //BA.debugLineNum = 88;BA.debugLine="cell.Tile = AniTile";
_cell.setTile((com.badlogic.gdx.maps.tiled.TiledMapTile)(_anitile));
 //BA.debugLineNum = 90;BA.debugLine="Log(\"Keys\")";
anywheresoftware.b4a.keywords.Common.Log("Keys");
 //BA.debugLineNum = 91;BA.debugLine="Dim x As List = AniTile.Properties.GetAllKeys";
_x = new anywheresoftware.b4a.objects.collections.List();
_x = _anitile.getProperties().GetAllKeys();
 //BA.debugLineNum = 92;BA.debugLine="For Each key In x";
final anywheresoftware.b4a.BA.IterableList group48 = _x;
final int groupLen48 = group48.getSize();
for (int index48 = 0;index48 < groupLen48 ;index48++){
_key = group48.Get(index48);
 //BA.debugLineNum = 93;BA.debugLine="Log(key)";
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(_key));
 }
;
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
}
